/* MFCC.c */
/* David Weenink, 20010628 */

#include "MFCC.h"
#include "NUM2.h"

class_methods (MFCC, CC)
class_methods_end

MFCC MFCC_create (double tmin, double tmax, long nt, double dt, double t1,
	long maximumNumberOfCoefficients, double fmin_mel, double fmax_mel)
{
	MFCC me = new (MFCC);
	if (me == NULL || ! CC_init (me, tmin, tmax, nt, dt, t1,
		maximumNumberOfCoefficients, fmin_mel, fmax_mel)) forget (me);
	return me;
}

int MFCC_lifter (MFCC me, long lifter)
{
	long i, frame;
	double *c;

	Melder_assert (lifter > 0);
	
	if ((c = NUMdvector (1, my maximumNumberOfCoefficients)) == NULL) return 0;
	
	for (i=1; i <= my maximumNumberOfCoefficients; i++)
	{
		c[i] = (1 + lifter / 2 * sin (NUMpi * i / lifter));
	}
	
	for (frame=1; frame <= my nx; frame++)
	{
		CC_Frame cf = & my frame[frame];
		for (i=1; i <= cf -> numberOfCoefficients; i++)
		{
			cf -> c[i] *= c[i];
		}
	}
	
	NUMdvector_free (c, 1);
	return Melder_hasError ();
}

/* End of file MFCC.c */
